#!/usr/bin/python
## ################################################################# ##
## (C) SCRT - Information Security, 2007 - 2008 // author: ~SaD~     ##
## ################################################################# ##
## This program is free software: you can redistribute it and/or     ##
## modify it under the terms of the GNU General Public License as    ##
## published by the Free Software Foundation, either version 3 of    ##
## the License, or (at your option) any later version.               ##
## This program is distributed in the hope that it will be useful,   ##
## but WITHOUT ANY WARRANTY; without even the implied warranty of    ##
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     ##
## GNU General Public License for more details.                      ##
## You should have received a copy of the GNU General Public License ##
## along with this program. If not, see http://www.gnu.org/licenses. ##
## ################################################################# ##
## last mod: 2008-02-20

import re
import codecs
from ConfigParser import SafeConfigParser
import os.path

## ################################################################# ##
##                                INIT                               ##
## ################################################################# ##

new_prefix = os.path.abspath(os.path.curdir)

print 'This script will setup all the required webshag parameters.'

## ################################################################# ##
##                         NMAP PORT SCANNER                         ##
## ################################################################# ##

print 'Detecting Nmap port scanner...\t',

if os.path.exists('/usr/bin/nmap'):
    nmap = 'True'
    nmap_location = '/usr/bin/nmap'
    
    print 'Done!'
    
else:
    print 'Not Found!'
    
    user_nmap = raw_input("Nmap location (blank if not installed): ")
    if user_nmap != '':
        if os.path.isfile(user_nmap):
            nmap = 'True'
            nmap_location = user_nmap
        else:
            nmap = 'False'
            nmap_location = ''
            print 'Nmap not found. Port scan module will not be functional.'
    else:
        nmap = 'False'
        nmap_location = ''
        print 'Nmap not found. Port scan module will not be functional.'


## ################################################################# ##
##                         LIVE SEARCH APPID                         ##
## ################################################################# ##

live_id = ''
user_live = raw_input("Valid Live Search AppID (blank if none): ")
if user_live != '':
    live_id = user_live
else:
    print 'Domain information module will not be functional.'

## ################################################################# ##
##                              CONFIG FILE                          ##
## ################################################################# ##

print 'Patching source code to setup config file location...\t',

# setting path to config file
core_file = new_prefix + u'/webshag/core/core_file.py'
config_file = new_prefix + u'/config/webshag.conf'
exp = re.compile(r'CFG_FILE\s=\s(?P<path>.*)')
core = codecs.open(core_file, u'r', u'utf-8')
core_content = core.read()
core.close()
old_path = exp.findall(core_content)[-1]
core_content = core_content.replace(old_path, '\'' + config_file + '\'')
core = codecs.open(core_file, u'w', u'utf-8')
core.write(core_content)
core.close()

print 'Done!'

# setting the paths in config file
print 'Setting up path to file fuzzer lists...\t',
fuzzer_dir_list = new_prefix + u'/database/fuzzer/directory-list-2.3-small.txt'
fuzzer_file_list = new_prefix + u'/database/fuzzer/directory-list-1.0.txt'
print 'Done!'

print 'Setting up path to URL database files...\t',
custom_db_dir = new_prefix + u'/database/custom'
nikto_db_dir = new_prefix + u'/database/nikto'
print 'Done!'

print 'Setting up path to (IDS) proxies list...\t',
ids_rp_list = new_prefix + u'/database/proxies/proxies.txt'
print 'Done!'

print 'Writing changes to configuration file...\t',
configParser = SafeConfigParser()
configParser.readfp(codecs.open(config_file, u'r', u'utf-8'))
configParser.set(u'core_file', u'fuzzer_file_list', fuzzer_file_list)
configParser.set(u'core_file', u'fuzzer_dir_list', fuzzer_dir_list)
configParser.set(u'core_file', u'custom_db_dir', custom_db_dir)
configParser.set(u'core_file', u'nikto_db_dir', nikto_db_dir)

configParser.set('core_http', 'ids_rp_list', ids_rp_list)

configParser.set(u'module_info', u'live_id', live_id)

configParser.set(u'module_portscan', u'nmap', nmap)
configParser.set(u'module_portscan', u'nmap_location', nmap_location)

cfg = codecs.open(config_file, u'w', u'utf-8')
configParser.write(cfg)
cfg.close()

print 'Done!'

## ################################################################# ##
##                                 END                               ##
## ################################################################# ##

print ''
print 'Thanks for your interest in webshag! It is now ready to be used!'
print 'If you move webshag folder, run this script again to reconfigure.'
print ''
print 'Enjoy! For more information please visit www.scrt.ch'
